/**
 * Wowza server software and all components Copyright 2006 - 2015, Wowza Media Systems, LLC, licensed pursuant to the Wowza Media Software End User License Agreement.
 */
package com.wowza.wms.plugin.collection.module;

import com.wowza.wms.application.*;
import com.wowza.wms.module.*;
import com.wowza.wms.stream.IMediaReader;

public class ModuleContentSourceSelector extends ModuleBase
{
	public static final String MODULE_NAME = "ModuleContentSourceSelector";
	public static final String PROP_NAME_PREFIX = "contentSourceSelector";
	
	public static final String SOURCE_SELECTOR_RANDOM_ACCESS_READER_CLASS = "com.wowza.wms.plugin.collection.mediareaders.RandomAccessReaderSourceSelector";
	
	public void onAppStart(IApplicationInstance appInstance)
	{
		String randomAccessReaderClass = appInstance.getMediaReaderProperties().getPropertyStr("randomAccessReaderClass", IMediaReader.DEFAULT_RANDOMACCESSREADER);
		if(!SOURCE_SELECTOR_RANDOM_ACCESS_READER_CLASS.equals(randomAccessReaderClass))
		{
			appInstance.getMediaReaderProperties().setProperty("randomAccessReaderClass", SOURCE_SELECTOR_RANDOM_ACCESS_READER_CLASS);
		}
		appInstance.getProperties().setProperty(PROP_NAME_PREFIX + "RandomAccessReaderClass", randomAccessReaderClass);
	}
	
}
